diff --git a/jerry-core/ecma/operations/ecma-objects-general.c b/jerry-core/ecma/operations/ecma-objects-general.c
index d2ee7466f1..53b40a0448 100644
--- a/jerry-core/ecma/operations/ecma-objects-general.c
+++ b/jerry-core/ecma/operations/ecma-objects-general.c
@@ -79,12 +79,11 @@ ecma_op_create_object_object_arg (ecma_value_t value) /**< argument of construct
 {
   ecma_check_value_type_is_spec_defined (value);
 
-  if (ecma_is_value_object (value)
-      || ecma_is_value_number (value)
-      || ecma_is_value_prop_name (value)
-      || ecma_is_value_boolean (value))
+  if (!ecma_is_value_undefined (value)
+      && !ecma_is_value_null (value))
   {
     /* 1.b, 1.c, 1.d */
+
     return ecma_op_to_object (value);
   }
   else
diff --git a/tests/jerry/es.next/regression-test-issue-4138.js b/tests/jerry/es.next/regression-test-issue-4138.js
new file mode 100644
index 0000000000..9f04d24789
--- /dev/null
+++ b/tests/jerry/es.next/regression-test-issue-4138.js
@@ -0,0 +1,15 @@
+// Copyright JS Foundation and other contributors, http://js.foundation
+//
+// Licensed under the Apache License, Version 2.0 (the "License");
+// you may not use this file except in compliance with the License.
+// You may obtain a copy of the License at
+//
+//     http://www.apache.org/licenses/LICENSE-2.0
+//
+// Unless required by applicable law or agreed to in writing, software
+// distributed under the License is distributed on an "AS IS" BASIS
+// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+// See the License for the specific language governing permissions and
+// limitations under the License.
+
+new Object(0n);
